program FR1215Z;

(**************************************
 * Testprogramm fr die Karte FR 1215 *
 *             als Zhler             *
 **************************************)

USES Crt;
CONST  adresse : array [0..3] of integer = ($100,$104,$108,$10C);
       Ende    : boolean = FALSE;
VAR  k,i  : integer;
     ch   : char;

procedure Bildschirm;
var   j : integer;
begin
     clrscr;
     gotoXY(20,3); write('       Zhlerprfprogramm');
     gotoXY(20,4); write('------------------------------------------------');
     for k:=0 to 3 do begin
         for j:=0 to 2 do begin
             gotoXY(23,6+3*k+j); write('Zhler Nr. ');
             write(k*10+j:2);
             write('           Wert = ');
         end;
     end;
     gotoXY(20,19); write('------------------------------------------------');
     gotoXY(20,20); writeln('Taste 0 = Zhler 0              Leertaste = Ende');
     writeln('');
     writeln('-------> Achtung: 1. Flanke High/Low bernimmt den geladenen Zhlerzustand');
     writeln('     Dieser Impuls fehlt im Ergebnis. Die nchsten Flanken High/Low zhlen.');
     writeln('          Abhilfe: Laden mit Wert+1 oder beim Ergebnis +1 addieren');
end;

procedure Initialisieren;
begin
     for k:=0 to 3 do begin
         Port[adresse[k]+3]:=$30; Port[adresse[k]]:=0; Port[adresse[k]]:=0;
         Port[adresse[k]+3]:=$70; Port[adresse[k]+1]:=0; Port[adresse[k]+1]:=0;
         Port[adresse[k]+3]:=$B0; Port[adresse[k]+2]:=0; Port[adresse[k]+2]:=0;
     end;
end;

procedure Nullsetzen;
begin
     for k:=0 to 3 do
         for i:=0 to 2 do begin
             Port[adresse[k]+i]:=$FF; Port[adresse[k]+i]:=$FF;
         end;
end;

procedure Lesen;
var   A,B     : integer;
      IZ      : array [0..3] of array [0..2] of integer;
begin
     for k:=0 to 3 do begin
         Port[adresse[k]+3]:=$0; Port[adresse[k]+3]:=$40;
         Port[adresse[k]+3]:=$80;
     end;
     for k:=0 to 3 do
         for i:=0 to 2 do begin
             A:=Port[adresse[k]+i]; B:=Port[adresse[k]+i];
             A:=A xor 255; B:=B xor 255;
             IZ[k] [i]:=A+256*B;
             gotoXY(60,6+3*k+i); write(IZ[k] [i]:5);
         end;
end;

BEGIN
     Bildschirm;
     Initialisieren;
     Nullsetzen;
     repeat
           if keypressed then begin
              ch:=readkey;
              if ch='0' then Nullsetzen
              else Ende:=TRUE;
           end;
           Lesen;
     until Ende;
END.